/* Copyright (C) 1997 Itoh Hidenori */

/*
 *  $Biuz"s((BV~$BIVIj(B[^(OD$B}=qH(Bp$B{i(B)
 *
 *  $Bx-Gpn}Gp(B/$BpmG4oPG5(Bobt@
 */

/* VXe$BID(Bwb_$BGCx-Gpn}Gp(B */
#include <stdio.h>

/* wb_$BGCx-Gpn}Gp(B */
#include "buffer.h"
#include "pmalloc.h"

/* $BhytptJjh(B */
buf_t	*buf_create();
void	buf_destroy();
void	buf_add();

buf_t	*buf_init();
int	buf_read();
int	buf_ar();


/* $BhytpzMeA(B */


/* $Bz"s.(BppbP[W$BGJiOt*G*IH(B */
buf_t *
buf_create() {
    buf_t	*buf = (buf_t *)pmalloc(sizeof(buf_t));
    buf->data = NULL;
    buf->size = buf->pos = 0;

    return buf;
}

/* $Bz"s.(BppbP[W$BGJ(Bj$Bd](B */
void
buf_destroy(buf)
    buf_t	*buf;
{
    free((char *)buf->data);
    free((char *)buf);

    return;
}

/* $Bz"s.(BppbP[W$BG3(Bdata$BGJn8GMGH(B */
void
buf_add(buf, data, size)
    buf_t	*buf;
    char	*data;
    int		size;
{
    int		tmp_size = sizeof(int) + size;

    if(buf->size - buf->pos < tmp_size) {
		buf->size = buf->pos + tmp_size;
		buf->data = prealloc(buf->data, buf->size);
#if 0
		if (buf->data)
		    buf->data = realloc(buf->data, buf->size);
		else
		    buf->data = malloc(buf->size);
#endif /* 0 */
    }
    memcpy(&buf->data[buf->pos], (char *)&size, sizeof(int));
    buf->pos += sizeof(int);
    memcpy(&buf->data[buf->pos], data, size);
    buf->pos += size;

    return;
}

/* $Br]s.IE(BbZ[W$BGI(B$Bz"s.(BppbP[W$BG4n8GMGH(B */
buf_t *
buf_init(data, size)
    char	*data;
    int		size;
{
    buf_t	*buf = (buf_t *)pmalloc(sizeof(buf_t));
    buf->data = pmalloc(size);
    memcpy(buf->data, data, size);
    buf->size = size;
    buf->pos = 0;

    return buf;
}

/* $Bz"s.(BppbP[W$BG)GA(Bdata$BGJn+GpoPG)(B*/
int
buf_read(buf, data)
    buf_t	*buf;
    char	*data;
{
    int		size;

    memcpy((char *)&size, &buf->data[buf->pos], sizeof(int));
    buf->pos += sizeof(int);
    memcpy(data, &buf->data[buf->pos], size);
    buf->pos += size;

    return size;
}

int
buf_ar(buf, data)
    buf_t	*buf;
    char	**data;
{
    int		size;

    memcpy((char *)&size, &buf->data[buf->pos], sizeof(int));
    buf->pos += sizeof(int);
    *data = pmalloc(size);
    memcpy(*data, &buf->data[buf->pos], size);
    buf->pos += size;

    return size;
}
    
