/* Copyright (C) 1997 Itoh Hidenori */

#include "shogi.h"

extern BOARD	*bd ;

/* $@0LCV(J tyx $@$+$i(J jyx $@$X(J $@Ht$SMx$-$,$"$k$+D4$Y$k!#Mx$-$"$j(J:$@JV$jCM#1(J */
int tobi_kiki(vec,jyx,tyx)
UC	vec,jyx,tyx;
{	    
    int flag = 1 ;
    UC temp ;
    
    for (temp = jyx + vec ;temp != tyx ;temp += vec)
	if (bd->yx[temp] != EMP) {
	    flag = 0 ;
	    break ;
	}		
    return(flag);
}

/* $@@h<j!'0LCV(J tyx $@$G(J $@6p(J code $@$,(J $@0LCV(J jyx $@$KMx$-$,$"$k$+D4$Y$k!#(J*/
/* $@8e<j!'0LCV(J jyx $@$G(J $@6p(J code $@$,(J $@0LCV(J tyx $@$KMx$-$,$"$k$+D4$Y$k!#(J*/
int kiki_table(code,jyx,tyx,flag)	/* $@JVCM(J 1$@!'6p$NMx$-M-$j(J 0$@!'$J$7(J	 */
UC code,jyx,tyx;		/* code$@!'6p$N<oN`(J yx$@!'3F6p$N:BI8(J */
int flag;				/* flag$@!'#1H?E>(J			 */
{
    int dummy = 0 ;
    UC dyx,vec = 0 ;
    char temp1,temp2 ;
    
    dyx = jyx - tyx ;
    
    switch(code)
    {
      case AIGOMA:	
	break ;
      case FU:
	if (dyx == FD) 					dummy = 1 ;
	break ;
      case KY:
	if (((jyx & 0x0f) == (tyx & 0x0f)) &&
	    (jyx < tyx) && tobi_kiki(BD,jyx,tyx)) 	dummy = 1 ;
	break ;
      case KE:
	if ((dyx == KL) || (dyx == KR)) 		dummy = 1 ;
	break ;
      case GI:
	if ((dyx == FL) || (dyx == FD) || (dyx == FR) ||

	    (dyx == BL) || 		  (dyx == BR) )	dummy = 1 ;
	break ;
      case KI:
	if ((dyx == FL) || (dyx == FD) || (dyx == FR) ||
	    (dyx == LT) ||		  (dyx == RT) ||
	                   (dyx == BD)		      )	dummy = 1 ;
	break ;
      case UM:
	if (               (dyx == FD) || 
	    (dyx == LT) ||		  (dyx == RT) ||
	                   (dyx == BD)		      ) dummy = 1 ;
      case KA:
	temp1 = (jyx >> 4) - (tyx >> 4) ;
	temp2 = (jyx & 0x0f) - (tyx & 0x0f) ;
	if (temp1 == temp2)				/* $@1&>e%i%$%s(J */
	{
	    if (tyx > jyx) vec = BL ;			/* $@6L:82<$K3Q(J */
	    if (tyx < jyx) vec = FR ;			/* $@6L1&>e$K3Q(J */
	    if (tobi_kiki(vec,jyx,tyx)) dummy = 1 ;
	}
	if (temp1 == -temp2)				/* $@1&2<%i%$%s(J */
	{
	    if (tyx > jyx) vec = BR ;  			/* $@6L1&2<$K3Q(J */
	    if (tyx < jyx) vec = FL ;  			/* $@6L:8>e$K3Q(J */
	    if (tobi_kiki(vec,jyx,tyx)) dummy = 1 ;
	}
	break ;
      case RY:
	if ((dyx == FL) || 		  (dyx == FR) ||

	    (dyx == BL) ||                (dyx == BR) )	dummy = 1 ;
      case HI:
	if ((jyx & 0x0f) == (tyx & 0x0f))
	{
	    if (tyx > jyx) vec = BD ;
	    if (tyx < jyx) vec = FD ;
	    if (tobi_kiki(vec,jyx,tyx)) dummy = 1 ;
	}
	if ((jyx & 0xf0) == (tyx & 0xf0))
	{
	    if (tyx > jyx) vec = LT ;
	    if (tyx < jyx) vec = RT ;
	    if (tobi_kiki(vec,jyx,tyx)) dummy = 1 ;
	}
	break ;
      case OU:
	if ((dyx == FL) || (dyx == FD) || (dyx == FR) ||
	    (dyx == LT) ||		  (dyx == RT) ||
	    (dyx == BL) || (dyx == BD) || (dyx == BR) ) dummy = 1 ;
	break ;
      default:
	if ((dyx == FL) || (dyx == FD) || (dyx == FR) ||
	    (dyx == LT) ||		  (dyx == RT) ||
	                   (dyx == BD)  	      ) dummy = 1 ;
    }
    return (dummy ^ flag);
}
