/* Copyright (C) 1997 Itoh Hidenori */

#include "shogi.h"
#include "proc.h"

extern BOARD		*bd ;
extern UC 		sente_tobi_kiki[256] ;	

extern int 	kiki_table();
extern void 	update_board_sente();
extern void	reupdate_board_sente();
extern void	update_board_gote();
extern void	reupdate_board_gote();
extern void	update_sente_tobi_kiki_map() ;
extern void 	set_pin_num();
extern void 	move_koma();
extern void 	load_data();
extern void	print_te();
extern void	rm_list();
extern void 	send_and_recv_msg();
extern void 	add_tree_list();
extern void     search_tree();
extern void	reconstruct_tree();
extern int	present_sashite();
extern int	index_fuc();
extern void	check_move_ote();
extern void	check_uchi_ote();

/* $B@h<j$N2&<j$r9M$($k(B */
void sente_ote(node,ote_list_rear,p_flag,get_koma)	
USI node,*ote_list_rear ;
PLAY_FLAG *p_flag ;
int get_koma ;
{
  UC ptr ;
  int i,dummy_code,uchi_goma_flag[16] ;
  int rule2,rule3,rule4,rule5 ;
  
  /* $B;}$A6p$rBG$C$F2&<j(B */
  if ((bd->sente_on_board != NILL) || (bd->tobi_koma != 0)){
    ptr = bd->sente_in_hand ;
    if (ptr != NILL) {
      for(i=0;i<16;i++) uchi_goma_flag[i] = 1 ;
      
      /* $B9bB.2=$N$?$a$N%k!<%k#3(B:
	 $B6p$rBG$C$F2&<j$r3]$1!"<h$i$l!"$=$N<h$C$?6p$,85$$$?0LCV$K(B
	 $BMx$-$,$"$k;~!"$=$N6p$,85$$$?0LCV$K6p$rBG$D2&<j$OFI$^$J$$(B
	 $B!J<h$i$l$l$P!";}6p$,8:$C$?$@$1!K!#(B			*/
	rule3 = 
	    (p_flag->ote_from_yx == 0x00) &&   
		(p_flag->ukete_get_koma == p_flag->ote_num) &&
		    kiki_table(bd->koma[p_flag->ukete_num].code,
			       bd->koma[p_flag->ukete_num].yx,
			       p_flag->ukete_from_yx,KIKIARI) ;
        
      /* $B9bB.2=$N$?$a$N%k!<%k#4(B:
	 $B6p$r0\F0$7$F6LJ}$N6p$r<h$i$:$K2&<j$r3]$1!"(B
	 $B6L$K<h$i$l$?;~!"2&<j$r3]$1$?6p$,(B
	 $B6p$r85$$$?0LCV$XF1$86p$rBG$D2&<j$O!"FI$^$J$$(B
	 $B!JF($2$i$l$l$P!";}6p$,8:$C$?$@$1!K!#(B			*/
      rule4 = 
	  (p_flag->ote_from_yx != 0x00) &&
	      (p_flag->ukete_get_koma == p_flag->ote_num) &&
		  (p_flag->ukete_num == bd->ou_num) &&
		      get_koma ;

      switch (p_flag->ote_pre_code)  {
      case FU:
      case KY:
      case KE:
      case GI:
      case KI:
      case HI:
      case RY:
      case KA:
      case UM:
	dummy_code = p_flag->ote_pre_code ;
	break ;
      default:
	dummy_code = KI;
      }
		
      while (ptr != NILL) {
	if (uchi_goma_flag[bd->koma[ptr].code] == 1)    {
	  uchi_goma_flag[bd->koma[ptr].code] = 0 ;
	  check_uchi_ote(node,ote_list_rear,ptr,
			 p_flag->ukete_from_yx,
			 p_flag->ote_from_yx,
			 dummy_code,rule3,rule4);
	}
	ptr = bd->koma[ptr].next ;
      }
    }
  }
  /* $BHW>e$N6p$N0\F0$K$h$k2&<j(B */
    
  /* $B9bB.2=$N$?$a$N%k!<%k#2(B:
       $B6p$rBG$C$F2&<j$r3]$1!"6L$,L#J}$N6p$r<h$i$:$KF($2$?;~!"(B
       $BBG$C$?6p$r6L$,85$$$?0LCV$K0\F0$9$k2&<j$OFI$^$J$$(B
       $B!J<h$i$l$l$P!";}6p$,8:$C$?$@$1!K!#(B			*/
  rule2 = 
      (p_flag->ote_from_yx == 0x00) &&   
	  (p_flag->ukete_num == bd->ou_num) && 
	      (p_flag->ukete_get_koma == EMP) ;
    
  /* $B9bB.2=$N$?$a$N%k!<%k#5(B:
     $B6p$r@.$i$J$$$G0\F0$7$F6LJ}$N6p$r<h$i$:$K2&<j$r3]$1!"(B
     $B6L$,F($2$?;~!"2&<j$r3]$1$?6p$r85$N0LCV$X@.$i$J$$$G0\F0$9$k(B
     $B2&<j$O!"FI$^$J$$!J85$N0LCV$XF($2$i$l$l$P!"F1$8!K!#(B	*/
  rule5 = 
      (p_flag->ote_from_yx != 0x00) &&
	  (p_flag->ote_nari == 0) &&
	      (p_flag->ukete_num == bd->ou_num) && 
		  get_koma ;
        
  ptr = bd->sente_on_board ;
  while (ptr != NILL) {
    if (bd->ou_num != ptr)
	check_move_ote(node,ote_list_rear,ptr,p_flag->ote_num,
		       rule2,rule5,p_flag) ;
    ptr = bd->koma[ptr].next ;
  }

}
